uses crt,nwconn,nwmisc,nwserv,nwbindry;

var
 StationNbr    : byte;
 StationAddress: TinternetworkAddress;
 hwaddr:boolean;

procedure Whoami;
begin
 GetConnectionNumber(StationNbr);
 IF GetInternetAddress(StationNbr,StationAddress)
  then begin
       writeln('Station #',StationNbr,' is [',
               HexDumpStr(StationAddress.net,8),
               ':',HexDumpStr(StationAddress.node,12),']');
       writeln('and communicates with the server via socket ',
               HexStr(StationAddress.socket,4));
       end;
end;


type screentype = record
       name:string[5];
       lines:array[1..22] of String[80];
     end;
     pctype = record
               isconn:boolean;
               isnode:boolean;
               node: Tnodeaddress;
               loc: String[10];
               name,fullname:string[20];
               conn:byte;
               datetime  : TnovTime;
              end;

const max_pc=100;

var  screen : array[1..10] of screentype;
     screen_max,
     screen_curr:byte;

     pc : array[1..max_pc] of pctype;


function getfirstword(s:string):string;
var i:byte;
begin
  i:=1;
  while (s[i]<>' ') and (i<length(s)) do inc(i);
  if s[i]=' ' then dec(i);
  getfirstword:=copy(s,1,i);
end;

procedure getnode(s:string;var n:Tnodeaddress);
const hex : array[0..15] of char
          = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
var i,j:byte;
begin
  for i:=1 to 6 do n[i]:=0;
  for i:=1 to length(s) do
    begin
      j:=0;
      while (j<15) and (upcase(s[i])<>hex[j]) do inc(j);
      inc(n[7-length(s) div 2+(i-1) div 2],i mod 2*16*j+(1-i mod 2)*j);
    end;
end;

procedure ScanDat;
var t:text;
    s,s1:string;
    l:byte;
    x:byte;
    code:integer;
begin
  screen_max:=0;
  fillchar(screen,sizeof(screen),0);
  fillchar(pc,sizeof(pc),0);

  assign(t,'nstat.dat');
  reset(t);

  while not eof(t) do
    begin
      readln(t,s);
      if s[1]='.' then begin
        delete(s,1,1);
        if copy(s,1,4)='view' then
          begin
            delete(s,1,5);
            inc(screen_max);
            screen[screen_max].name:=s;
            l:=1;
          end;
        if copy(s,1,2)='pc' then
          begin
            delete(s,1,3);
            s1:=getfirstword(s);
            val(s1,x,code);
            delete(s,1,length(s1)+1);
            getnode(getfirstword(s),pc[x].node);
            pc[x].isnode:=true;
          end;
      end else begin
        screen[screen_max].lines[l]:=s;
        inc(l);
      end;
    end;

  close(t);
end;


function fullstr(s:string;c:byte):string;
var i:byte; s1:string;
begin
  s1:=copy(s,1,c);
  while length(s1)<c do s1:=s1+' ';
  fullstr:=s1;
end;


procedure writescreen(sc:byte);
var i,j,x:byte;
    s,s1:string[80];
    code:integer;
begin
  with screen[sc] do
    begin
      textcolor(lightgray);
      textbackground(black);
      for i:=1 to 22 do
        begin
          gotoxy(1,i+1);
          write(lines[i]);
        end;
      textcolor(white);
      for i:=1 to 22 do
        begin
          s:=lines[i];
          for j:=1 to length(s) do
            if s[j]='@' then
              begin
                s1:=getfirstword(copy(s,j+1,80));
                val(s1,x,code);
                if pc[x].isnode then
                  begin
                    textbackground(blue);
                    if (pc[x].conn=0) or (pc[x].name='NOT-LOGGED-IN') then textbackground(green);
                    if pc[x].conn=StationNbr then textbackground(red);
                    if hwaddr then begin
                       gotoxy(j,i+3);
                       write('PC',x:3,' ',hexdumpstr(pc[x].node,12));
                    end;

                    if pc[x].isconn then
                      begin
                        gotoxy(j,i+1);
                        write(pc[x].conn:3,': ',fullstr(pc[x].name,13));
                        gotoxy(j,i+2);
                        write(fullstr(pc[x].fullName,18));
                      end else begin
                        gotoxy(j,i+1); write('   --- frei ---   ');
                        gotoxy(j,i+2); write('                  ');
                      end;
                  end else begin
                    textbackground(lightgray);
                    gotoxy(j,i+1); write('                  ');
                    gotoxy(j,i+2); write('                  ');
                    gotoxy(j,i+1); write(s1);
                  end;
              end;
        end;
    end;
end;


procedure readconn;
var
 connNbr   : byte;
 name      : string;
 oType     : Word;
 oID       : LongInt;
 datetime  : TnovTime;
 serverInfo: TFileServerInformation;
 i,j:byte;
 address: Tinternetworkaddress;
 Fullname:string;
begin
  GetFileServerInformation(ServerInfo);
  for connNbr := 1 to ServerInfo.ConnectionsMax { NW 386: 250 }
  do if GetConnectionInformation(connNbr,name,oType,oID,datetime)
       and (oType=1) then
    begin
{      writeln(name,' logged in at ',datetime.day,'/',datetime.month,'/'
              ,datetime.year,' ',datetime.hour,':',datetime.min);}
      GetInternetAddress(connnbr,address);
      for i:=1 to max_pc do
        if  (address.node[1]=pc[i].node[1])
        and (address.node[2]=pc[i].node[2])
        and (address.node[3]=pc[i].node[3])
        and (address.node[4]=pc[i].node[4])
        and (address.node[5]=pc[i].node[5])
        and (address.node[6]=pc[i].node[6]) then
          begin
            pc[i].isconn:=true;
            pc[i].name:=name;
            pc[i].datetime:=datetime;
            pc[i].conn:=connnbr;
            GetRealUserName(name,Fullname);
            pc[i].FullName:=FullName;
          end;
   end;
end;

var ende,updatemode:boolean;
    i:byte;
    ch:char;
    time:word;
begin
  whoami;
  scandat;

  screen_curr:=1;
  ende:=false;
  updatemode:=false;
  hwaddr:=false;

  repeat
    textbackground(black);
    clrscr;
    textcolor(black);
    textbackground(lightgray);
    writeln('   Netzwerk Status  -  Gymnasium Zum Altenforst  -  (c) O. Schmidt, 9.1.97     ');

    readconn;
    writescreen(screen_curr);

    gotoxy(1,24); textbackground(lightgray);
    for i:=1 to screen_max do
      begin
        if i=screen_curr then textcolor(yellow)
                         else textcolor(black);
        write(' ',i,'=',screen[i].name,' ');
      end;
    textcolor(black);
    gotoxy(1,25); write(' e=Ende  h=HW-Addr ');
    if updatemode then textcolor(yellow);
    write(' u=Updatemode ');

    time:=0;

    while not keypressed and (not updatemode or (time<500)) do
      begin inc(time); delay(10); end;

    if keypressed then begin
       ch:=upcase(readkey);
       case ch of
         'E','Q':ende:=true;
         'H':hwaddr:=not hwaddr;
         '1'..'9': if byte(ch)-48 <= screen_max then
           screen_curr:=byte(ch)-48;
         'U': updatemode:=not updatemode;
       end;
    end;
  until ende;

  textbackground(black);
  textcolor(lightgray);
  clrscr;
  writeln('   Netzwerk Status  -  Gymnasium Zum Altenforst  -  (c) O. Schmidt, 9.1.97'^j);
end.